package com.wuban.tron.explore.entity.example;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 合约表 查询条件example类
 * @author sky
 * @date 2020-12-01
 */
public class ContractExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public ContractExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria)this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria)this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria)this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria)this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria)this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria)this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria)this;
        }

        public Criteria andBytecodeIsNull() {
            addCriterion("bytecode is null");
            return (Criteria)this;
        }

        public Criteria andBytecodeIsNotNull() {
            addCriterion("bytecode is not null");
            return (Criteria)this;
        }

        public Criteria andBytecodeEqualTo(String value) {
            addCriterion("bytecode =", value, "bytecode");
            return (Criteria)this;
        }

        public Criteria andBytecodeNotEqualTo(String value) {
            addCriterion("bytecode <>", value, "bytecode");
            return (Criteria)this;
        }

        public Criteria andBytecodeIn(List<String> values) {
            addCriterion("bytecode in", values, "bytecode");
            return (Criteria)this;
        }

        public Criteria andBytecodeNotIn(List<String> values) {
            addCriterion("bytecode not in", values, "bytecode");
            return (Criteria)this;
        }

        public Criteria andBytecodeBetween(String value1, String value2) {
            addCriterion("bytecode between", value1, value2, "bytecode");
            return (Criteria)this;
        }

        public Criteria andBytecodeNotBetween(String value1, String value2) {
            addCriterion("bytecode not between", value1, value2, "bytecode");
            return (Criteria)this;
        }


        public Criteria andBytecodeLike(String value) {
            addCriterion("bytecode like", value, "bytecode");
            return (Criteria)this;
        }

        public Criteria andBytecodeNotLike(String value) {
            addCriterion("bytecode not like", value, "bytecode");
            return (Criteria)this;
        }
        public Criteria andNameIsNull() {
            addCriterion("name is null");
            return (Criteria)this;
        }

        public Criteria andNameIsNotNull() {
            addCriterion("name is not null");
            return (Criteria)this;
        }

        public Criteria andNameEqualTo(String value) {
            addCriterion("name =", value, "name");
            return (Criteria)this;
        }

        public Criteria andNameNotEqualTo(String value) {
            addCriterion("name <>", value, "name");
            return (Criteria)this;
        }

        public Criteria andNameIn(List<String> values) {
            addCriterion("name in", values, "name");
            return (Criteria)this;
        }

        public Criteria andNameNotIn(List<String> values) {
            addCriterion("name not in", values, "name");
            return (Criteria)this;
        }

        public Criteria andNameBetween(String value1, String value2) {
            addCriterion("name between", value1, value2, "name");
            return (Criteria)this;
        }

        public Criteria andNameNotBetween(String value1, String value2) {
            addCriterion("name not between", value1, value2, "name");
            return (Criteria)this;
        }


        public Criteria andNameLike(String value) {
            addCriterion("name like", value, "name");
            return (Criteria)this;
        }

        public Criteria andNameNotLike(String value) {
            addCriterion("name not like", value, "name");
            return (Criteria)this;
        }
        public Criteria andOriginAddressIsNull() {
            addCriterion("origin_address is null");
            return (Criteria)this;
        }

        public Criteria andOriginAddressIsNotNull() {
            addCriterion("origin_address is not null");
            return (Criteria)this;
        }

        public Criteria andOriginAddressEqualTo(String value) {
            addCriterion("origin_address =", value, "originAddress");
            return (Criteria)this;
        }

        public Criteria andOriginAddressNotEqualTo(String value) {
            addCriterion("origin_address <>", value, "originAddress");
            return (Criteria)this;
        }

        public Criteria andOriginAddressIn(List<String> values) {
            addCriterion("origin_address in", values, "originAddress");
            return (Criteria)this;
        }

        public Criteria andOriginAddressNotIn(List<String> values) {
            addCriterion("origin_address not in", values, "originAddress");
            return (Criteria)this;
        }

        public Criteria andOriginAddressBetween(String value1, String value2) {
            addCriterion("origin_address between", value1, value2, "originAddress");
            return (Criteria)this;
        }

        public Criteria andOriginAddressNotBetween(String value1, String value2) {
            addCriterion("origin_address not between", value1, value2, "originAddress");
            return (Criteria)this;
        }


        public Criteria andOriginAddressLike(String value) {
            addCriterion("origin_address like", value, "originAddress");
            return (Criteria)this;
        }

        public Criteria andOriginAddressNotLike(String value) {
            addCriterion("origin_address not like", value, "originAddress");
            return (Criteria)this;
        }
        public Criteria andAbiIsNull() {
            addCriterion("abi is null");
            return (Criteria)this;
        }

        public Criteria andAbiIsNotNull() {
            addCriterion("abi is not null");
            return (Criteria)this;
        }

        public Criteria andAbiEqualTo(String value) {
            addCriterion("abi =", value, "abi");
            return (Criteria)this;
        }

        public Criteria andAbiNotEqualTo(String value) {
            addCriterion("abi <>", value, "abi");
            return (Criteria)this;
        }

        public Criteria andAbiIn(List<String> values) {
            addCriterion("abi in", values, "abi");
            return (Criteria)this;
        }

        public Criteria andAbiNotIn(List<String> values) {
            addCriterion("abi not in", values, "abi");
            return (Criteria)this;
        }

        public Criteria andAbiBetween(String value1, String value2) {
            addCriterion("abi between", value1, value2, "abi");
            return (Criteria)this;
        }

        public Criteria andAbiNotBetween(String value1, String value2) {
            addCriterion("abi not between", value1, value2, "abi");
            return (Criteria)this;
        }


        public Criteria andAbiLike(String value) {
            addCriterion("abi like", value, "abi");
            return (Criteria)this;
        }

        public Criteria andAbiNotLike(String value) {
            addCriterion("abi not like", value, "abi");
            return (Criteria)this;
        }
        public Criteria andOriginEnergyLimitIsNull() {
            addCriterion("origin_energy_limit is null");
            return (Criteria)this;
        }

        public Criteria andOriginEnergyLimitIsNotNull() {
            addCriterion("origin_energy_limit is not null");
            return (Criteria)this;
        }

        public Criteria andOriginEnergyLimitEqualTo(Long value) {
            addCriterion("origin_energy_limit =", value, "originEnergyLimit");
            return (Criteria)this;
        }

        public Criteria andOriginEnergyLimitNotEqualTo(Long value) {
            addCriterion("origin_energy_limit <>", value, "originEnergyLimit");
            return (Criteria)this;
        }

        public Criteria andOriginEnergyLimitIn(List<Long> values) {
            addCriterion("origin_energy_limit in", values, "originEnergyLimit");
            return (Criteria)this;
        }

        public Criteria andOriginEnergyLimitNotIn(List<Long> values) {
            addCriterion("origin_energy_limit not in", values, "originEnergyLimit");
            return (Criteria)this;
        }

        public Criteria andOriginEnergyLimitBetween(Long value1, Long value2) {
            addCriterion("origin_energy_limit between", value1, value2, "originEnergyLimit");
            return (Criteria)this;
        }

        public Criteria andOriginEnergyLimitNotBetween(Long value1, Long value2) {
            addCriterion("origin_energy_limit not between", value1, value2, "originEnergyLimit");
            return (Criteria)this;
        }

        public Criteria andOriginEnergyLimitGreaterThan(Long value) {
            addCriterion("origin_energy_limit >", value, "originEnergyLimit");
            return (Criteria)this;
        }

        public Criteria andOriginEnergyLimitGreaterThanOrEqualTo(Long value) {
            addCriterion("origin_energy_limit >=", value, "originEnergyLimit");
            return (Criteria)this;
        }

        public Criteria andOriginEnergyLimitLessThan(Long value) {
            addCriterion("origin_energy_limit <", value, "originEnergyLimit");
            return (Criteria)this;
        }

        public Criteria andOriginEnergyLimitLessThanOrEqualTo(Long value) {
            addCriterion("origin_energy_limit <=", value, "originEnergyLimit");
            return (Criteria)this;
        }

        public Criteria andContractAddressIsNull() {
            addCriterion("contract_address is null");
            return (Criteria)this;
        }

        public Criteria andContractAddressIsNotNull() {
            addCriterion("contract_address is not null");
            return (Criteria)this;
        }

        public Criteria andContractAddressEqualTo(String value) {
            addCriterion("contract_address =", value, "contractAddress");
            return (Criteria)this;
        }

        public Criteria andContractAddressNotEqualTo(String value) {
            addCriterion("contract_address <>", value, "contractAddress");
            return (Criteria)this;
        }

        public Criteria andContractAddressIn(List<String> values) {
            addCriterion("contract_address in", values, "contractAddress");
            return (Criteria)this;
        }

        public Criteria andContractAddressNotIn(List<String> values) {
            addCriterion("contract_address not in", values, "contractAddress");
            return (Criteria)this;
        }

        public Criteria andContractAddressBetween(String value1, String value2) {
            addCriterion("contract_address between", value1, value2, "contractAddress");
            return (Criteria)this;
        }

        public Criteria andContractAddressNotBetween(String value1, String value2) {
            addCriterion("contract_address not between", value1, value2, "contractAddress");
            return (Criteria)this;
        }


        public Criteria andContractAddressLike(String value) {
            addCriterion("contract_address like", value, "contractAddress");
            return (Criteria)this;
        }

        public Criteria andContractAddressNotLike(String value) {
            addCriterion("contract_address not like", value, "contractAddress");
            return (Criteria)this;
        }
        public Criteria andCodeHashIsNull() {
            addCriterion("code_hash is null");
            return (Criteria)this;
        }

        public Criteria andCodeHashIsNotNull() {
            addCriterion("code_hash is not null");
            return (Criteria)this;
        }

        public Criteria andCodeHashEqualTo(String value) {
            addCriterion("code_hash =", value, "codeHash");
            return (Criteria)this;
        }

        public Criteria andCodeHashNotEqualTo(String value) {
            addCriterion("code_hash <>", value, "codeHash");
            return (Criteria)this;
        }

        public Criteria andCodeHashIn(List<String> values) {
            addCriterion("code_hash in", values, "codeHash");
            return (Criteria)this;
        }

        public Criteria andCodeHashNotIn(List<String> values) {
            addCriterion("code_hash not in", values, "codeHash");
            return (Criteria)this;
        }

        public Criteria andCodeHashBetween(String value1, String value2) {
            addCriterion("code_hash between", value1, value2, "codeHash");
            return (Criteria)this;
        }

        public Criteria andCodeHashNotBetween(String value1, String value2) {
            addCriterion("code_hash not between", value1, value2, "codeHash");
            return (Criteria)this;
        }


        public Criteria andCodeHashLike(String value) {
            addCriterion("code_hash like", value, "codeHash");
            return (Criteria)this;
        }

        public Criteria andCodeHashNotLike(String value) {
            addCriterion("code_hash not like", value, "codeHash");
            return (Criteria)this;
        }
        public Criteria andVersionIsNull() {
            addCriterion("version is null");
            return (Criteria)this;
        }

        public Criteria andVersionIsNotNull() {
            addCriterion("version is not null");
            return (Criteria)this;
        }

        public Criteria andVersionEqualTo(String value) {
            addCriterion("version =", value, "version");
            return (Criteria)this;
        }

        public Criteria andVersionNotEqualTo(String value) {
            addCriterion("version <>", value, "version");
            return (Criteria)this;
        }

        public Criteria andVersionIn(List<String> values) {
            addCriterion("version in", values, "version");
            return (Criteria)this;
        }

        public Criteria andVersionNotIn(List<String> values) {
            addCriterion("version not in", values, "version");
            return (Criteria)this;
        }

        public Criteria andVersionBetween(String value1, String value2) {
            addCriterion("version between", value1, value2, "version");
            return (Criteria)this;
        }

        public Criteria andVersionNotBetween(String value1, String value2) {
            addCriterion("version not between", value1, value2, "version");
            return (Criteria)this;
        }


        public Criteria andVersionLike(String value) {
            addCriterion("version like", value, "version");
            return (Criteria)this;
        }

        public Criteria andVersionNotLike(String value) {
            addCriterion("version not like", value, "version");
            return (Criteria)this;
        }
        public Criteria andSourceIsNull() {
            addCriterion("source is null");
            return (Criteria)this;
        }

        public Criteria andSourceIsNotNull() {
            addCriterion("source is not null");
            return (Criteria)this;
        }

        public Criteria andSourceEqualTo(String value) {
            addCriterion("source =", value, "source");
            return (Criteria)this;
        }

        public Criteria andSourceNotEqualTo(String value) {
            addCriterion("source <>", value, "source");
            return (Criteria)this;
        }

        public Criteria andSourceIn(List<String> values) {
            addCriterion("source in", values, "source");
            return (Criteria)this;
        }

        public Criteria andSourceNotIn(List<String> values) {
            addCriterion("source not in", values, "source");
            return (Criteria)this;
        }

        public Criteria andSourceBetween(String value1, String value2) {
            addCriterion("source between", value1, value2, "source");
            return (Criteria)this;
        }

        public Criteria andSourceNotBetween(String value1, String value2) {
            addCriterion("source not between", value1, value2, "source");
            return (Criteria)this;
        }


        public Criteria andSourceLike(String value) {
            addCriterion("source like", value, "source");
            return (Criteria)this;
        }

        public Criteria andSourceNotLike(String value) {
            addCriterion("source not like", value, "source");
            return (Criteria)this;
        }
        public Criteria andEnabledIsNull() {
            addCriterion("enabled is null");
            return (Criteria)this;
        }

        public Criteria andEnabledIsNotNull() {
            addCriterion("enabled is not null");
            return (Criteria)this;
        }

        public Criteria andEnabledEqualTo(String value) {
            addCriterion("enabled =", value, "enabled");
            return (Criteria)this;
        }

        public Criteria andEnabledNotEqualTo(String value) {
            addCriterion("enabled <>", value, "enabled");
            return (Criteria)this;
        }

        public Criteria andEnabledIn(List<String> values) {
            addCriterion("enabled in", values, "enabled");
            return (Criteria)this;
        }

        public Criteria andEnabledNotIn(List<String> values) {
            addCriterion("enabled not in", values, "enabled");
            return (Criteria)this;
        }

        public Criteria andEnabledBetween(String value1, String value2) {
            addCriterion("enabled between", value1, value2, "enabled");
            return (Criteria)this;
        }

        public Criteria andEnabledNotBetween(String value1, String value2) {
            addCriterion("enabled not between", value1, value2, "enabled");
            return (Criteria)this;
        }


        public Criteria andEnabledLike(String value) {
            addCriterion("enabled like", value, "enabled");
            return (Criteria)this;
        }

        public Criteria andEnabledNotLike(String value) {
            addCriterion("enabled not like", value, "enabled");
            return (Criteria)this;
        }
        public Criteria andOtherIsNull() {
            addCriterion("other is null");
            return (Criteria)this;
        }

        public Criteria andOtherIsNotNull() {
            addCriterion("other is not null");
            return (Criteria)this;
        }

        public Criteria andOtherEqualTo(String value) {
            addCriterion("other =", value, "other");
            return (Criteria)this;
        }

        public Criteria andOtherNotEqualTo(String value) {
            addCriterion("other <>", value, "other");
            return (Criteria)this;
        }

        public Criteria andOtherIn(List<String> values) {
            addCriterion("other in", values, "other");
            return (Criteria)this;
        }

        public Criteria andOtherNotIn(List<String> values) {
            addCriterion("other not in", values, "other");
            return (Criteria)this;
        }

        public Criteria andOtherBetween(String value1, String value2) {
            addCriterion("other between", value1, value2, "other");
            return (Criteria)this;
        }

        public Criteria andOtherNotBetween(String value1, String value2) {
            addCriterion("other not between", value1, value2, "other");
            return (Criteria)this;
        }


        public Criteria andOtherLike(String value) {
            addCriterion("other like", value, "other");
            return (Criteria)this;
        }

        public Criteria andOtherNotLike(String value) {
            addCriterion("other not like", value, "other");
            return (Criteria)this;
        }
        public Criteria andRunsIsNull() {
            addCriterion("runs is null");
            return (Criteria)this;
        }

        public Criteria andRunsIsNotNull() {
            addCriterion("runs is not null");
            return (Criteria)this;
        }

        public Criteria andRunsEqualTo(String value) {
            addCriterion("runs =", value, "runs");
            return (Criteria)this;
        }

        public Criteria andRunsNotEqualTo(String value) {
            addCriterion("runs <>", value, "runs");
            return (Criteria)this;
        }

        public Criteria andRunsIn(List<String> values) {
            addCriterion("runs in", values, "runs");
            return (Criteria)this;
        }

        public Criteria andRunsNotIn(List<String> values) {
            addCriterion("runs not in", values, "runs");
            return (Criteria)this;
        }

        public Criteria andRunsBetween(String value1, String value2) {
            addCriterion("runs between", value1, value2, "runs");
            return (Criteria)this;
        }

        public Criteria andRunsNotBetween(String value1, String value2) {
            addCriterion("runs not between", value1, value2, "runs");
            return (Criteria)this;
        }


        public Criteria andRunsLike(String value) {
            addCriterion("runs like", value, "runs");
            return (Criteria)this;
        }

        public Criteria andRunsNotLike(String value) {
            addCriterion("runs not like", value, "runs");
            return (Criteria)this;
        }
        public Criteria andEvmVersionIsNull() {
            addCriterion("evm_version is null");
            return (Criteria)this;
        }

        public Criteria andEvmVersionIsNotNull() {
            addCriterion("evm_version is not null");
            return (Criteria)this;
        }

        public Criteria andEvmVersionEqualTo(String value) {
            addCriterion("evm_version =", value, "evmVersion");
            return (Criteria)this;
        }

        public Criteria andEvmVersionNotEqualTo(String value) {
            addCriterion("evm_version <>", value, "evmVersion");
            return (Criteria)this;
        }

        public Criteria andEvmVersionIn(List<String> values) {
            addCriterion("evm_version in", values, "evmVersion");
            return (Criteria)this;
        }

        public Criteria andEvmVersionNotIn(List<String> values) {
            addCriterion("evm_version not in", values, "evmVersion");
            return (Criteria)this;
        }

        public Criteria andEvmVersionBetween(String value1, String value2) {
            addCriterion("evm_version between", value1, value2, "evmVersion");
            return (Criteria)this;
        }

        public Criteria andEvmVersionNotBetween(String value1, String value2) {
            addCriterion("evm_version not between", value1, value2, "evmVersion");
            return (Criteria)this;
        }


        public Criteria andEvmVersionLike(String value) {
            addCriterion("evm_version like", value, "evmVersion");
            return (Criteria)this;
        }

        public Criteria andEvmVersionNotLike(String value) {
            addCriterion("evm_version not like", value, "evmVersion");
            return (Criteria)this;
        }
        public Criteria andLicenseTypeIsNull() {
            addCriterion("license_type is null");
            return (Criteria)this;
        }

        public Criteria andLicenseTypeIsNotNull() {
            addCriterion("license_type is not null");
            return (Criteria)this;
        }

        public Criteria andLicenseTypeEqualTo(String value) {
            addCriterion("license_type =", value, "licenseType");
            return (Criteria)this;
        }

        public Criteria andLicenseTypeNotEqualTo(String value) {
            addCriterion("license_type <>", value, "licenseType");
            return (Criteria)this;
        }

        public Criteria andLicenseTypeIn(List<String> values) {
            addCriterion("license_type in", values, "licenseType");
            return (Criteria)this;
        }

        public Criteria andLicenseTypeNotIn(List<String> values) {
            addCriterion("license_type not in", values, "licenseType");
            return (Criteria)this;
        }

        public Criteria andLicenseTypeBetween(String value1, String value2) {
            addCriterion("license_type between", value1, value2, "licenseType");
            return (Criteria)this;
        }

        public Criteria andLicenseTypeNotBetween(String value1, String value2) {
            addCriterion("license_type not between", value1, value2, "licenseType");
            return (Criteria)this;
        }


        public Criteria andLicenseTypeLike(String value) {
            addCriterion("license_type like", value, "licenseType");
            return (Criteria)this;
        }

        public Criteria andLicenseTypeNotLike(String value) {
            addCriterion("license_type not like", value, "licenseType");
            return (Criteria)this;
        }
        public Criteria andParametersIsNull() {
            addCriterion("parameters is null");
            return (Criteria)this;
        }

        public Criteria andParametersIsNotNull() {
            addCriterion("parameters is not null");
            return (Criteria)this;
        }

        public Criteria andParametersEqualTo(String value) {
            addCriterion("parameters =", value, "parameters");
            return (Criteria)this;
        }

        public Criteria andParametersNotEqualTo(String value) {
            addCriterion("parameters <>", value, "parameters");
            return (Criteria)this;
        }

        public Criteria andParametersIn(List<String> values) {
            addCriterion("parameters in", values, "parameters");
            return (Criteria)this;
        }

        public Criteria andParametersNotIn(List<String> values) {
            addCriterion("parameters not in", values, "parameters");
            return (Criteria)this;
        }

        public Criteria andParametersBetween(String value1, String value2) {
            addCriterion("parameters between", value1, value2, "parameters");
            return (Criteria)this;
        }

        public Criteria andParametersNotBetween(String value1, String value2) {
            addCriterion("parameters not between", value1, value2, "parameters");
            return (Criteria)this;
        }


        public Criteria andParametersLike(String value) {
            addCriterion("parameters like", value, "parameters");
            return (Criteria)this;
        }

        public Criteria andParametersNotLike(String value) {
            addCriterion("parameters not like", value, "parameters");
            return (Criteria)this;
        }
        public Criteria andOptimizationIsNull() {
            addCriterion("optimization is null");
            return (Criteria)this;
        }

        public Criteria andOptimizationIsNotNull() {
            addCriterion("optimization is not null");
            return (Criteria)this;
        }

        public Criteria andOptimizationEqualTo(String value) {
            addCriterion("optimization =", value, "optimization");
            return (Criteria)this;
        }

        public Criteria andOptimizationNotEqualTo(String value) {
            addCriterion("optimization <>", value, "optimization");
            return (Criteria)this;
        }

        public Criteria andOptimizationIn(List<String> values) {
            addCriterion("optimization in", values, "optimization");
            return (Criteria)this;
        }

        public Criteria andOptimizationNotIn(List<String> values) {
            addCriterion("optimization not in", values, "optimization");
            return (Criteria)this;
        }

        public Criteria andOptimizationBetween(String value1, String value2) {
            addCriterion("optimization between", value1, value2, "optimization");
            return (Criteria)this;
        }

        public Criteria andOptimizationNotBetween(String value1, String value2) {
            addCriterion("optimization not between", value1, value2, "optimization");
            return (Criteria)this;
        }


        public Criteria andOptimizationLike(String value) {
            addCriterion("optimization like", value, "optimization");
            return (Criteria)this;
        }

        public Criteria andOptimizationNotLike(String value) {
            addCriterion("optimization not like", value, "optimization");
            return (Criteria)this;
        }
        public Criteria andFieldIsNull(final String fieldName) {
            addCriterion(fieldName + " is null");
            return (Criteria) this;
        }

        public Criteria andFieldIsNotNull(final String fieldName) {
            addCriterion(fieldName + " is not null");
            return (Criteria) this;
        }

        public Criteria andFieldEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " = ", fieldValue, fieldName);
            return (Criteria) this;
        }

        public Criteria andFieldNotEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " <> ", fieldValue, fieldName);
            return (Criteria) this;
        }

        public Criteria andFieldIn(final String fieldName, final List<Object> values) {
            addCriterion(fieldName + " in ", values, fieldName);
            return (Criteria) this;
        }

        public Criteria andFieldNotIn(final String fieldName, final List<Object> values) {
            addCriterion(fieldName + " not in ", values, fieldName);
            return (Criteria) this;
        }

        public Criteria andFieldBetween(final String fieldName, final Object fieldValue1,final Object fieldValue2) {
            addCriterion(fieldName + " between ", fieldValue1, fieldValue2, fieldName);
            return (Criteria) this;
        }

        public Criteria andFieldNotBetween(final String fieldName, final Object fieldValue1,final Object fieldValue2) {
            addCriterion(fieldName + "  not between ", fieldValue1, fieldValue2, fieldName);
            return (Criteria) this;
        }

        public Criteria andFieldGreaterThan(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " > ", fieldValue, fieldName);
            return (Criteria) this;
        }

        public Criteria andFieldGreaterThanOrEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " >= ", fieldValue, fieldName);
            return (Criteria) this;
        }

        public Criteria andFieldLessThan(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " < ", fieldValue, fieldName);
            return (Criteria) this;
        }

        public Criteria andFieldLessThanOrEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " <= ", fieldValue, fieldName);
            return (Criteria) this;
        }

        public Criteria andFieldLike(final String fieldName, final String fieldValue) {
            addCriterion(fieldName + " like ", fieldValue, fieldName);
            return (Criteria) this;
        }

        public Criteria andFieldNotLike(final String fieldName, final String fieldValue) {
            addCriterion(fieldName + "  not like ", fieldValue, fieldName);
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}
